package test;
/** Trie Data structure is extensively used for storing large key/value pairs as in dictionaries etc.. */
public class Trie {

	private TrieNode root;

	/* Constructor */
	public Trie() {
		root = new TrieNode(' ');
	}

	/* Function to insert key */
	public void create(String key, String value) {

		if (search(key) == true) {
			System.out
					.println("## Key '" + key + "' already exists ##");
			return;
		}
		TrieNode current = root;
		for (char ch : key.toCharArray()) {
			TrieNode child = current.subNode(ch);
			if (child != null)
				current = child;
			else {
				current.childList.add(new TrieNode(ch));
				current = current.subNode(ch);
				current.value = value;
			}
			current.count++;
		}
		current.isEnd = true;

	}

	/*
	 * Function to search for a Key
	 */

	public boolean search(String key) {
		TrieNode current = root;
		for (char ch : key.toCharArray()) {
			if (current.subNode(ch) == null)
				return false;
			else
				current = current.subNode(ch);
		}
		if (current.isEnd == true)
			return true;
		return false;
	}

	/**
	 * Function to get the value associated with a key
	 */
	public String getValue(String key) {
		TrieNode current = root;
		String value = null;
		for (char ch : key.toCharArray()) {

			current = current.subNode(ch);
		}
		if (current.isEnd == true) {
			value = current.value;
		}

		return value;
	}

	/* Function to delete the key */

	public void delete(String key) {
		if (search(key) == false) {
			System.out.println("## Key '" + key + "' does not exist ##");
			return;
		}
		TrieNode current = root;
		for (char ch : key.toCharArray()) {
			TrieNode child = current.subNode(ch);
			if (child.count == 1) {
				current.childList.remove(child);
				return;
			} else {
				child.count--;
				current = child;
			}
		}
		current.isEnd = false;
	}

	/** function to update the value of a key **/
	public void update(String key, String value) {

		TrieNode current = root;

		for (char ch : key.toCharArray()) {

			current = current.subNode(ch);
		}
		if (current.isEnd == true) {
			current.value = value;
		}

	}

}
